/*----------------------------------------------------------------
 * Copyright (C) 2011 մѧ ѧԺ416 ԭ
 * ȨС 
 * 
 * ļ AD7708.c
 * 
 * ļ   
 *          MSP430F16x,MSP430F14XϵеƬⲿAD
 *      ˵  ֮ͨǰʵֵSPIAD7708ͨ
 *              ţAD7708УADתȡ
 *              
 *              ÷AD7708.c뵽ĿͬʱҪô
 *              ĳļмAD7708.h;
 *              ʹͷļĳˣϸɲο   
 *              main.c
 *              
 *              AD7708 Ĵѡ
 *              A3	A2	A1	A0	ѡĴ
 *              0	0	0	0	дͨżĴ
 *              0	0	0	0	״̬Ĵ
 *              0	0	0	1	ģʽĴ
 *              0	0	1	0	ADCƼĴ
 *              0	0	1	1	˲Ĵ
 *              0	1	0	0	ADCݼĴ
 *              0	1	0	1	ADCƫƼĴ
 *              0	1	1	0	ADCĴ
 *              0	1	1	1	I/OƼĴ
 *              1	0	0	0	δ
 *              1	0	0	1	δ
 *              1	0	1	0	δ
 *              1	0	1	1	δ
 *              1	1	0	0	ԼĴ
 *              1	1	0	1	ԼĴ
 *              1	1	1	0	δ
 *              1	1	1	1	IDĴ
 * 
 *              ҪAD7718·ȫ䣬16λȡΪ
 *              24λļɡ
 * 		
 * ʶ   ԭ20110814
 * 
 * ޸ıʶ   
 * ޸   
**----------------------------------------------------------------*/
#include "msp430x16x.h" //430Ĵͷļ
#include "AD7708.h"     //ad7708ͷļļú
#include "Spi.h"        //SPIͨѶͷļ

char IsLong[16] = {0,0,0,0,1,1,1,0,0,0,0,0,1,1,0,0};
char mode,adccon;

/****************************************************************************
*     ƣAD7708WriteRegister
*     ܣAD7708Ĵд
* ڲ
*           addr  ڲĴַ
*           dat:    Ҫд
* ڲ
****************************************************************************/
void AD7708WriteRegister(char addr,long dat)
{
    SpiWriteData(addr);     //дͨżĴ֪ͨ¸дaddrĴ
    if(IsLong[addr])        //16λĴ, 771824λֲҪif
    {
        SpiWriteData(dat>>8);
    }
    SpiWriteData(0xFF&dat);       //дλ
}

/****************************************************************************
*     ƣAD7708ReadRegister
*     ܣĳڲĴ
* ڲaddrڲĴַ
* ڲlong
****************************************************************************/
long AD7708ReadRegister(char addr)
{
    char h = 0,l = 0;           //ߵֽ
    SpiWriteData(0x40|addr);    //дͨżĴ֪ͨ¸addrĴ
    if(IsLong[addr])
    {
        h = SpiWriteData(0xFF);
    }
    l = SpiWriteData(0xFF);
    return ((unsigned int)h<<8)|l;
}

/****************************************************************************
*     ƣAD7708ReadResultData
*     ܣȡת
* ڲ
* ڲAD
* ˵    : AD7708:16λݣֲ771824λݣĶȡһֽ
****************************************************************************/
long AD7708ReadResultData()
{
    while((AD7708ReadRegister(0x00)&0x80)==0); //ȴת
    return AD7708ReadRegister(0x04);
}

/****************************************************************************
*     ƣAD7708Cal
*     ܣУ׼AD7708
* ڲchannel:ҪУ׼ͨ
* ڲ
* ˵    : AD7708УΪڲУ׼Ӧƽ˴
*           ϵͳУ׼Ҫӡ
****************************************************************************/
void AD7708Cal(char channel)
{
    adccon = (adccon&0x0f)|(channel<<4);
    mode = (mode&0xf8)|0x04;                //ڲ0У׼
    AD7708WriteRegister(0x02,adccon);       //ADCƼĴchannelͨ
    AD7708WriteRegister(0x01,mode);         //ģʽĴ
    while((AD7708ReadRegister(0x01)&0x07)!=0x01);   //ȴУ׼
    
    mode = (mode&0xf8)|0x05;                //ڲ У׼
    AD7708WriteRegister(0x01,mode);         //ģʽĴ
    while((AD7708ReadRegister(0x01)&0x07)!=0x01);   //ȴУ׼
}

/****************************************************************************
*     ƣAD7708Init
*     ܣʼAD7708
* ڲchop:ն־ Ϊ1ն0
* ڲ
* ˵    : AD7708ĳʼ
****************************************************************************/
void AD7708Init(char chop)
{
    P3DIR|=BIT0;
    P3OUT&=~BIT0;                       //CSѡ
    //ģʽ115200,8λλģʽʱģʽ1spi.c
    SpiMasterInit(115200,8,3,1);        //ʱӲ׼ȷ115200spi.c
    _EINT();                            //жϣspiдҪҪж
    
    char filter;
    adccon = 0x0f;
    if(chop == 0)
    {
        filter = 0x03;                  //˲ĴΪСֵԸ
        mode = 0x91;                    //նֹ10ͨ޻壬ģʽ
    }
    else
    {
        filter = 0x0D;                  //˲ĴΪСֵԸ
        mode = 0x11;                    //նã10ͨ޻壬ģʽ
    }
    
    AD7708WriteRegister(0x07,0x00);     //IOĴ==
    AD7708WriteRegister(0x03,filter);   //˲Ĵ
    AD7708WriteRegister(0x02,0x0F);     //ADCƼĴ0ͨ
    AD7708WriteRegister(0x01,mode);     //ģʽĴ
    if(chop == 0)
        for(int i = 0; i<5;i++)
        {
            //У׼ֻ5ʧĴľͻḲ֮ǰģֻУ׼5
            AD7708Cal(5);
        }
    
    _DINT();
}

/****************************************************************************
*     ƣAD7708Start
*     ܣAD7708תʼ
* ڲchannelͨ
* ڲ
* ˵    : ת
****************************************************************************/
void AD7708Start(char channel)
{
    adccon = (adccon&0x0f)|(channel<<4);
    mode = (mode&0xf8)|0x02;
    AD7708WriteRegister(0x02,adccon);
    AD7708WriteRegister(0x01,mode);
}
