/*----------------------------------------------------------------
 * Copyright (C) 2011 մѧ ѧԺ416 ԭ
 * ȨС 
 * 
 * ļ ADC12.c
 * 
 * ļ   
 *          MSP430F16xϵеƬADC12
 *      ˵  
 *          óADC12ģͨóܣԺʹã
 *          ҪʵˣADC12ģĳʼʵ
 *          ͨĵκͶתͨĿò,ͨ
 *          ģʽһͨ.ADC12תADC12
 *          ʼADתжϳԼӴ(ʵ
 *          ʹõͨ)
 *          
 *      
 *      ʹ÷ʽ
 *          мADC12.cļ,ԴļADC12.hļ
 *          ;жϴԼĴ߼Բο
 *          Ŀ
 *          
 * ʶ   ԭ20110823
 * 
 * ޸ıʶ   
 * ޸   
**----------------------------------------------------------------*/

#include <msp430x16x.h>
#include "ADC12.h"

int results[3][32];

/********************************************************
* ƣADC12Init
*     ܣADC12ʼ
*     
*           nʹͨ160-15ʹ
*           channels[]:ӦͨãλοԴѡ
            λͨѡ񡣾£
            SREFx Bits
            6-4
            Select reference
            000 VR+ = AVCC and VR. = AVSS
            001 VR+ = VREF+ and VR. = AVSS
            010 VR+ = VeREF+ and VR. = AVSS
            011 VR+ = VeREF+ and VR. = AVSS
            100 VR+ = AVCC and VR. = VREF./ VeREF.
            101 VR+ = VREF+ and VR. = VREF./ VeREF.
            110 VR+ = VeREF+ and VR. = VREF./ VeREF.
            111 VR+ = VeREF+ and VR. = VREF./ VeREF.
            INCHx Bits
            3-0
            Input channel select
            0000 A0
            0001 A1
            0010 A2
            0011 A3
            0100 A4
            0101 A5
            0110 A6
            0111 A7
            1000 VeREF+
            1001 VREF./VeREF.
            1010 Temperature sensor
            1011 (AVCC C AVSS) / 2
            1100 (AVCC C AVSS) / 2
            1101 (AVCC C AVSS) / 2
            1110 (AVCC C AVSS) / 2
            1111 (AVCC C AVSS) / 2
*           rep0ģʽ 0 
*   ֵɹ1󷵻 0
* ˵    ˳ADͨõĳʼѡõʱ
            SMCLKοѹڲ򿪵2.5v(ҪʱԸ
            ıڲοѹֵر֮)
*********************************************************/
char ADC12Init(char n,char channels[],char rep)
{
    if(n>15)
        return 0;
    //SHT0_0 
    ADC12CTL0 = ADC12ON + MSC + SHT0_0 + REFON + REF2_5V;// ad,οѹ2.5v
    ADC12CTL1 = SHP + ADC12SSEL_3;                  //Use sampling timer, SMCLK
    
    for(int i = 0;i < n;i++)
    {
        if(channels[i] >= 0x80)
            return 0;
        *(char*)(ADC12MCTL0_ + i) = channels[i];    //ÿMCTL
    }
    *(char*)(ADC12MCTL0_ + n - 1) |= EOS;           //н
    
    if(rep != 0)                                  //ת
    {
        ADC12CTL1 |= CONSEQ_3;
    }
    else
    {
        ADC12CTL1 |= CONSEQ_1;
    }
    
    ADC12IE = 1<<(n-1);                                 // Enable ADC12IFG.n-1
    return 1;
}

/********************************************************
* ƣADC12Start
*     ܣADC12ʼת
*     
*   ֵ
* ˵    ʼɺô˺ADC12ʼת
*********************************************************/
void ADC12Start()
{
    ADC12CTL0 |= ENC;
    ADC12CTL0 |= ADC12SC;
}

/********************************************************
* ƣADC12ISR
*     ܣADC12жϴ
*     
*   ֵ
* ˵    ÿεͨתɺ󣬴жʱƬ
            ԶñʹʱҪԼӴ߼ɾ
            ڵĺ塣
*********************************************************/
#pragma vector=ADC_VECTOR
__interrupt void ADC12ISR (void)
{
    static int i;
    results[0][i] = ADC12MEM0;                // Move results, IFG is cleared
    results[1][i] = ADC12MEM1;                // Move results, IFG is cleared
    results[2][i] = ADC12MEM2;                // Move results, IFG is cleared
    i++;
    if(i>31)                                  //תʱ ת
    {
        //ظʱ﷽
        ADC12CTL0 &=~ ENC;                      //ֹͣת
        i=0;
    }

}