/*----------------------------------------------------------------
 * Copyright (C) 2011 մѧ ѧԺ416 ԭ
 * ȨС 
 * 
 * ļ TAPwm.c
 * 
 * ļ   
 *          MSP430F16x,MSP430F14XϵеƬSpiͨѶ(򻯰)
 *      ˵  ɶʱTA·PWM,Է
 *              ռձȡǴӡMSP430ϵеƬϵͳ
 *              ʵⱾTA_PWMֲġֻԭĻ
                ˶˿
 *      ʹ÷
 *              мTAPwm.cļļTAPwm.hļȻ
 *              ʹñĺ
 * 		
 * ʶ   ԭ20110826
 * 
 * ޸ıʶ   
 * ޸   
**----------------------------------------------------------------*/

#include <msp430x16x.h>
#include "TAPwm.h"

/****************************************************************************
*     ƣTAPwmInit
*     ܣTAʱΪPWMĳʼú             
* ڲClk:ʱԴ 'S'=SMCLK;   'A'=ACLK ;     _____
                       'E'=TACLK(ⲿ)    'e'= TACLK(TACLKȡ)
            Div:ʱӷƵϵ: 1/2/4/8
            Mode1:ͨ1ģʽ 'P'Ϊߵƽ'N'͵ƽ 0=
            Mode2:ͨ2ģʽ 'P'Ϊߵƽ'N'͵ƽ 0=

* ڲ1ʾóɹ0ʾʧܡ
* ˵    : ڵPWMغ֮ǰҪøúTAģʽʱԴ
*     : TAPwmInit('A',1,'P','P')TAʱΪACLK,ͨ1ͨ2Ϊߵƽ
            TAPwmInit('S',4,'N','N')TAʱΪSMCLK/4, ͨ12Ϊ͵ƽ
            TAPwmInit('A',1,'P',0)TAʱΪACLK,ͨ1ߵƽ,ͨ2,
            õPWMͨܽԿΪͨIOʹá
****************************************************************************/
char TAPwmInit(char Clk,char Div,char Mode1,char Mode2)
{
    TACTL = 0;                  //ǰ
    TACTL |= MC_1;              //ʱTAΪģʽ  
    switch(Clk)                 //ѡʱԴ
    { 
        case 'A': case 'a':  TACTL|=TASSEL_1; break;    //ACLK
        case 'S': case 's':  TACTL|=TASSEL_2; break;    //SMCLK
        case 'E':            TACTL|=TASSEL_0; break;    //ⲿ(TACLK)
        case 'e':            TACTL|=TASSEL_3; break;    //ⲿ(TACLKȡ)
        default :  return(0);                           //
    } 
    switch(Div)                 //ѡƵϵ
    { 
        case 1:   TACTL|=ID_0; break;   //1
        case 2:   TACTL|=ID_1; break;   //2
        case 4:   TACTL|=ID_2; break;   //4
        case 8:   TACTL|=ID_3; break;   //8
        default :  return(0);           //
    } 
    switch(Mode1)               //PWMͨ1ģʽ
    { 
        case 'P':case 'p':          //Ϊߵƽģʽ
            TACCTL1 = OUTMOD_7;     //ߵƽPWM
            P1SEL |= BIT2;          //P1.2 (ͬͺŵƬܲһ)
            P1DIR |= BIT2;          //P1.2 (ͬͺŵƬܲһ)              
            break;
        case 'N':case 'n':          //Ϊ͵ƽģʽ          
            TACCTL1 = OUTMOD_3;     //͵ƽPWM
            P1SEL |= BIT2;          //P1.2 (ͬͺŵƬܲһ) 
            P1DIR |= BIT2;          //P1.2 (ͬͺŵƬܲһ)                
            break; 
        case '0':case 0:            //Ϊ          
            P1SEL &= ~BIT2;         //P1.2ָΪͨIO              
            break;                 
        default :  return(0);       //
    } 
    switch(Mode2)                   //PWMͨ1ģʽ
    { 
        case 'P':case 'p':          //Ϊߵƽģʽ
            TACCTL2 =OUTMOD_7;      //ߵƽPWM
            P1SEL |= BIT3;          //P1.3 (ͬͺŵƬܲһ)
            P1DIR |= BIT3;          //P1.3 (ͬͺŵƬܲһ)
            break;
        case 'N':case 'n':          //Ϊ͵ƽģʽ          
            TACCTL2 =OUTMOD_3;      //͵ƽPWM
            P1SEL |= BIT3;          //P1.3 (ͬͺŵƬܲһ)  
            P1DIR |= BIT3;          //P1.3 (ͬͺŵƬܲһ)              
            break; 
        case '0':case 0:            //Ϊ          
            P1SEL &= ~BIT3;         //P1.3ָΪͨIO              
            break;                 
        default :  return(0);       //
    }    
    return(1);  
}

/****************************************************************************
*     ƣTAPwmSetPeriod
*     ܣPWM             
* ڲPeriod:(0~65535) ʱӸ
* ڲ
* ˵    : ö2·PWMͬʱЧ
*     : TAPwmSetPeriod(500)PWMΪ500ʱ
****************************************************************************/
void TAPwmSetPeriod(unsigned int Period)
{
    TACCR0 = Period;
}

/****************************************************************************
*     ƣTAPwmSetDuty
*     ܣPWM"Ч"ʱ             
* ڲChannel: ǰõͨ  1/2
            Duty:    PWMЧʱ(0~65535) ʱӸ
* ڲ
* ˵    : ͨģʽΪߵƽģʽDutyֵڸߵƽʱӸ
            ͨģʽΪ͵ƽģʽDutyֵڵ͵ƽʱӸ
*     : TAPwmSetDuty(1,30)PWMͨ1ĸߵƽΪ30ʱ
            TAPwmSetDuty(2,80)PWMͨ2ĸߵƽΪ80ʱ
****************************************************************************/
void TAPwmSetDuty(char Channel,unsigned int Duty)
{
    switch(Channel)
    {
        case 1: TACCR1=Duty; break; 
        case 2: TACCR2=Duty; break;    
    }
}

/****************************************************************************
*     ƣTAPwmSetPermill
*     ܣPWMռձ(ǧֱ)             
* ڲChannel: ǰõͨ  1/2
            Percent: PWMЧʱǧֱ (0~1000) 
* ڲ
* ˵    : 1000=100.0%  500=50.0%         
*     : TAPwmSetPermill(1,300)PWMͨ1ռձΪ30.0%
            TAPwmSetPermill(2,825)PWMͨ2ռձΪ82.5%
****************************************************************************/
void TAPwmSetPermill(char Channel,unsigned int Percent)
{
    unsigned long int Period;
    unsigned int Duty;
    Period = TACCR0;
    Duty = Period * Percent / 1000;
    TAPwmSetDuty(Channel,Duty);
}