/*----------------------------------------------------------------
 * Copyright (C) 2011 մѧ ѧԺ416 ԭ
 * ȨС 
 * 
 * ļ Flash.c
 * 
 * ļ   
 *          MSP430F16x,MSP430F14XϵеƬFlash
 *      ˵  
 *          óFlashģͨó⣬ñ
 *          FlashĲдֻֽڣûʵֿд빦
 *          ܡڳɲеĶΣ ʹʱһҪע
 *          ⣬ҪѼеĳʹʱע⣬Flash
 *          ÿд󣬲ڲ֮ǰٴдݣ 
 *          𺦡
 *      ʹ÷ʽ
 *          мFlash.CļļFlash.h Ȼ󼴿ʹ
 *          ĺˡ
 *          
 * ʶ   ԭ20110830
 * 
 * ޸ıʶ   
 * ޸   
**----------------------------------------------------------------*/

#include <msp430x16x.h>
#include "Flash.h"

unsigned char FlashSR;
/*=======================궨==========================*/
#define DINT    FlashSR=__get_SR_register();_DINT() // жϣ״̬Ĵ
#define EINT    if(FlashSR & GIE)           _EINT() //ݱĽж ж
/*=======================================================*/

/************************************************************
* ƣFlashInit
*     ܣFlashؼĴԴʼ
*     
*   ֵ
* ˵    ʹó֮ǰӦȵô˺
*************************************************************/
void FlashInit()
{
    FCTL2 = FWKEY + FSSEL_2 + FN1;          // Ĭ SMCLK/3 =333KHz 
}

/****************************************************************************
*     ƣWaitForEnable
*     ܣFlashæȴ
* ڲ 
* ڲ
* ˵    : FlashæȴֱFlash()ŷء
****************************************************************************/
void WaitForEnable()
{
    while((FCTL3 & BUSY) == BUSY);      //Busy
}

/****************************************************************************
*     ƣFlashErase
*     ܣFlashһݶ
* ڲAddr:ݶε׵ַ 
* ڲ
****************************************************************************/
void FlashErase(unsigned int Addr)  
{ 
    char *FlashPtr;
    FlashPtr = (char *)Addr;
    FCTL1 = FWKEY + ERASE;                      // Set Erase bit
    FCTL3 = FWKEY;                              // Clear Lock bit
    DINT;
    *FlashPtr = 0;                              // Dummy write to erase Flash segment B
    WaitForEnable();                            //Busy
    EINT;
    FCTL1 = FWKEY;                              // Lock
    FCTL3 = FWKEY + LOCK;                       // Set Lock bit  
}

/****************************************************************************
*     ƣFlashWriteChar
*     ܣFlashдһֽ(Charͱ)
* ڲAddr:ݵĵַ
            Data:д
* ڲ
* ˵    ַֻżԶǰһλ
*     FlashWriteChar(0x1000,123);123д0x1000Ԫ
            FlashWriteChar(0x1002,a);ͱaд0x1002Ԫ 
****************************************************************************/
void FlashWriteChar(unsigned int addr,char Data)
{
    char *FlashPtr = (char *)addr;              // Segment A pointer
    FCTL1 = FWKEY + WRT;                        // Set WRT bit for write operation
    FCTL3 = FWKEY;                              // Clear Lock bit
    DINT;
    *FlashPtr = Data;                           // Save Data
    WaitForEnable();                            //Busy
    EINT;
    FCTL1 = FWKEY;                              // Clear WRT bit
    FCTL3 = FWKEY + LOCK;                       // Set LOCK bit
}  

/****************************************************************************
*     ƣFlashWriteChar
*     ܣFlashдһ(޷ͱ)
* ڲAddr:ݵĵַ
            Data:д
* ڲ
*     FlashWriteChar(0x1000,123);123д0x1000Ԫ
            FlashWriteChar(0x1002,a);ͱaд0x1002Ԫ 
****************************************************************************/
void FlashWriteWord(unsigned int addr,unsigned int Data)
{
    unsigned int *FlashPtr = (unsigned int *)addr;
    FCTL1 = FWKEY + WRT;                        // Set WRT bit for write operation
    FCTL3 = FWKEY;                              // Clear Lock bit
    DINT;
    *FlashPtr = Data;                           // Save Data
    WaitForEnable();                            //Busy
    EINT;
    FCTL1 = FWKEY;                              // Clear WRT bit
    FCTL3 = FWKEY + LOCK;                       // Set LOCK bit
}  

/****************************************************************************
*     ƣFlashReadChar
*     ܣFlashжȡһֽ
* ڲAddr:ݵĵַ
* ڲص
****************************************************************************/
char FlashReadChar(unsigned int Addr)
{ 
    char Data;
    char *FlashPtr = (char *) Addr; 
    Data = *FlashPtr;
    return(Data);
}

/****************************************************************************
*     ƣFlashReadWord
*     ܣFlashжȡһ
* ڲAddr:ݵĵַ
* ڲصݣ޷ͣ
****************************************************************************/
unsigned int FlashReadWord(unsigned int Addr)
{ 
    unsigned int Data;
    unsigned int *FlashPtr = (unsigned int *)Addr; 
    Data = *FlashPtr;
    return(Data);
}
