/*----------------------------------------------------------------
 * Copyright (C) 2011 մѧ ѧԺ416 ԭ
 * ȨС 
 * 
 * ļ Key.c
 * 
 * ļ   
 *          MSP430F16x,MSP430F14XϵеƬ̳
 *      ˵  
 *          óɱȽͨõļ̿⺯ֻдGetKeyͼ
 *          KeyCodeɺܷİѳֲּ̡
 *
 *          ʹʱֻKey.cӵУȻҪü̵ĳļ
 *          мKey.hİȻͿԵͷļĸ
 *          scanfֲʱس˸ҵǰϽǵ
 *          Ϊ˸½ǵΪسȻ9 1-9һ
 *           0ĸ'\0'
 *          "123\b456\000789\0\0000\0\r";  4*4,scanfֲ
 *          
 * ʶ   ԭ20110820
 * 
 * ޸ıʶ   
 * ޸   
**----------------------------------------------------------------*/

#include <msp430x16x.h>
#include <stdio.h>
#include "Key.h"

/**********************궨***********************/
#define KeySize     4           //ֵ
#define Length      KeySize+1   //Ԫظ
/***************************************************/

/**********************ֵ*********************/
//KeySize(Length-1)ѭռһԪؿռ
char Key[Length];
//char KeyCode[] = "0123";    /*4ʱ*/
//char KeyCode[] = "0123456789ABCDEF"; /* 4*4ʱ*/

char KeyCode[] = "123\b456\000789\0\0000\0\r"; /* 4*4,scanfֲ*/
char front;             //ָ
char rear;              //βָ
/***************************************************/

/************************************************
ƣKeyInit
    ܣõԴʼ
    
ֵ  
*************************************************/
void KeyInit()
{
    WDTCTL=WDT_ADLY_16;   //Źڲʱģʽ16ms
    IE1 |= WDTIE;         //Źж
    front = 0;
    rear = 0;
}

/************************************************
ƣReadKey
    ܣӼ̶жȡֵ
    
ֵ  ׼ֵ
*************************************************/
char ReadKey()
{
    char temp;
    //if(rear==front) return '\0';    //ް
    while(rear==front);
    temp = Key[front];
    front=(front+1)%Length;
    return temp;
}

/************************************************
ƣAddKeyCode
    ܣ̶мֵ
    
ֵ  
*************************************************/
void AddKeyCode(char keyCode)
{
    if((rear+1)%Length==front)      //
    {
        front=(front+1)%Length;     //һ
    }
    Key[rear] = keyCode;
    rear=(rear+1)%Length;
}

/************************************************
ƣGetKey
    ܣȡԭʼֵް򷵻0xFF(4)
    
ֵ  ԭʼɨõļֵ
˵    4͵ƽЧP1.0-P1.3
*************************************************/
/*char GetKey()
{
    if((P1IN&0X0F)==0x0E)
    {
        return 0;
    }
    if((P1IN&0X0F)==0x0D)
    {
        return 1;
    }
    if((P1IN&0X0F)==0x0B)
    {
        return 2;
    }
    if((P1IN&0X0F)==0x07)
    {
        return 3;
    }
    return 0xff;
}*/

/************************************************
ƣGetKey
    ܣȡԭʼֵް򷵻0xFF(4*4)
    
ֵ  ԭʼɨõļֵ
˵    P1.0-P1.3룬P1.4-P1.7ɨ
*************************************************/
char GetKey()
{
    P1DIR |= 0XF0;                  //λ
    for(int i=0;i<4;i++)
    {
        P1OUT = 0XEF << i;
        for(int j=0;j<4;j++)
        {
            if((P1IN&(0x01<<j))==0)
            {
                return (i+4*j);
            }
        }
    }
    return 0xff;
}

/************************************************
ƣKeyProcess
    ܣ̴
    
ֵ  
˵    ˺Ϊ̺Ĵ,Ҫÿ10-20ms
          һΣжϺ
*************************************************/
void KeyProcess()
{
    static char keyValue = 0xff;    //ʶֵ
    static char addedFlag = 0;      //б־
    char keyVal = GetKey();
    if(keyVal==0xff)                //ް
    {
        keyValue = 0xff;
        addedFlag = 0;
        return;
    }
    if(keyValue==0xff)              //֮ǰ״̬ް
    {
        keyValue = keyVal;
        return;
    }
    if(keyValue!=keyVal)            //ǰΰͬ
    {
        keyValue = keyVal;          //°ֵ
        return;
    }
    if(addedFlag==1)                //Ѽ
    {
        return;
    }
    addedFlag = 1;
    AddKeyCode(KeyCode[keyVal]);
}

/************************************************
ƣWDT_ISR
    ܣŹʱжϣ16ms
    
ֵ  
*************************************************/
#pragma vector=WDT_VECTOR
__interrupt void WDT_ISR()
{
    KeyProcess();
}