/*----------------------------------------------------------------
 * Copyright (C) 2011 մѧ ѧԺ416 ԭ
 * ȨС 
 * 
 * ļ Spi.c
 * 
 * ļ   
 *          MSP430F16x,MSP430F14XϵеƬSpiͨѶ(򻯰)
 *      ˵  Spiĳʼݡݣ
 *              ֻmsp430spiģʽӻģʽֻʱ
 *              ӺͲȥɣοûָϣ
 *              MSP430 SPI ͬдʱʱӲṩСƵ
 *              brclk/baudΪƵϵСƵֱӺ
 *              ʹSpi÷Spi.c뵽ĿͬʱҪô
 *              ĳļмSpi.h䣻
 *              ʹͷļĳˣϸɲο   
 *              main.c
 *               ҪΪUSART1ģ飬ֻѺ궨x Ӧ0Ϊ
 *              1ɣҪͬʱʹ01ģ飬ҪѺ
 *              ָΪͬļֱ01ģ
 * 		
 * ʶ   ԭ20110808
 * 
 * ޸ıʶ   ԭ20110819
 * ޸   дͬʱضȡֵSpiWriteData(char c)
 *              Ϊģ飬ÿдݣṩ8λʱڣ
 *              ÿεдݷأ7λҲ
 *              Ҫ.͡վô˺ͷļҲӦ
 *              ģȥֻȡдĺȡʱ,ã
 *              =============SpiWriteDatWithReturn(0xFF)===========
 * 
**----------------------------------------------------------------*/

#include <msp430x16x.h>
#include "Spi.h"

/***********************************궨*********************************/
#define UxCTL   U0CTL
#define UxRCTL  U0RCTL
#define UxTCTL  U0TCTL

#define UxBR0   U0BR0
#define UxBR1   U0BR1
#define UxMCTL  U0MCTL

#define UxRXBUF U0RXBUF
#define UxTXBUF U0TXBUF

#define UxME    U0ME
#define UxIE    U0IE
#define UxIFG   U0IFG

#define USPIEx  USPIE0

#define URXIEx  URXIE0
#define UTXIEx  UTXIE0

#define USARTxTX_VECTOR USART0TX_VECTOR
#define USARTxRX_VECTOR USART0RX_VECTOR

#define USPI3ON P3SEL |= 0X0E           //SPI 0ĵڶܴ(ģʽ)
#define USPI4ON P3SEL |= 0X0F           //SPI 0ĵڶܴ(ģʽ)
/**************************************************************************/

char TxFlag=1;
char RxFlag=0;

/****************************************************************************
*     ƣSpiMasterInit
*     ܣʼSPIòʵȣģʽ
* ڲ
*           baud:             (300~500k)
                        ֻǴʹʱӵƵspiģʽUxMCTLĴЧ
                        ΪƵƵϵΪ ֣֧С
                        Ƶ
            datsBits:   λλ  (78)
            mode:       ֹͣλλ  (34)
                        3ģʽ  
                        4ģʽ
            clkMode     ʱģʽ    (0-3)   ʱӵļԺλ
                        0 طͣ½ؽ UCLK
                        1 ½طͣؽ UCLK
                        2 ½طͣؽ ʱUCLK
                        3 طͣ½ؽ ʱUCLK
* ڲֵΪ1ʱɹΪ0ʾд
*     : SpiMasterInit(9600,8,3,0)  //9600bps8λݣģʽʱ
                                        ģʽ0,9600ʣ32768ƵС
                                        ƵЧʵʲʣ9600
            SpiMasterInit(16364,7,4,1) //16364bps7λݣģʽ,ģʽ
                                        32768Ƶ
****************************************************************************/
char SpiMasterInit(long baud,char dataBits,char mode,char clkMode)
{
    long int brclk;                 //ʷʱƵ
    
    UxCTL |= SWRST;                 //ʼ
    
    //ѡλΪ1͵Լգڲԣʹʱע͵
    //UxCTL |= LISTEN;
    
    UxCTL |= SYNC + MM;             //SPI ģʽ
    
    //ʱԴ
    UxTCTL &=~ (SSEL0+SSEL1);       //֮ǰʱ
    if(baud<=16364)                 //
    {
      UxTCTL |= SSEL0;              //ACLK͹
      brclk = 32768;                //ʷʱƵ=ACLK(32768)
    }
    else
    {
      UxTCTL |= SSEL1;              //SMCLK֤ٶ
      brclk = 1000000;              //ʷʱƵ=SMCLK(1MHz)
    }
    
    //------------------------ò-------------------------   
    if(baud < 300||baud > 115200)   //ʳΧ
    {
        return 0;
    }
    //òʼĴ
    int fen = brclk / baud;         //Ƶϵ
    if(fen<2)return (0);            //Ƶϵ2
    else
    {
        UxBR0 = fen / 256;
        UxBR1 = fen % 256;
    }
    
    //------------------------λ-------------------------    
    switch(dataBits)
    {
        case 7:case'7': UxCTL &=~ CHAR; break;      //7λ
        case 8:case'8': UxCTL |= CHAR;  break;      //8λ
        default :       return(0);                  //
    } 
    //------------------------ģʽ---------------------------    
    switch(mode)
    {
        case 3:case'3': UxTCTL |= STC;  USPI3ON;    break;  //ģʽ
        case 4:case'4': UxTCTL &=~ STC; USPI4ON;    break;  //ģʽ
        default :       return(0);                          //
    }
    
    //------------------------UCLKģʽ-----------------------  
    switch(clkMode)
    {
        case 0:case'0': UxTCTL &=~ CKPH; UxTCTL &=~ CKPL;   break;  //ģʽ0
        case 1:case'1': UxTCTL &=~ CKPH; UxTCTL |= CKPL;    break;  //ģʽ1
        case 2:case'2': UxTCTL |= CKPH;  UxTCTL &=~ CKPL;   break;  //ģʽ2
        case 3:case'3': UxTCTL |= CKPH;  UxTCTL |= CKPL;    break;  //ģʽ3
        default :       return(0);                                  //
    }
    
    UxME |= USPIEx;             //ģʹ
    
    UCTL0 &= ~SWRST;            // Initialize USART state machine
    
    UxIE |= URXIEx + UTXIEx;    // Enable USART0 RX interrupt 
    
    return(1);                  //óɹ
}

/****************************************************************************
*     ƣUartLpm
*     ܣ/ȴУʱϵͳĲʱӸùصʡ
* ڲ
* ڲ
* ˵    : ʱӳͻע͵úӹġ
****************************************************************************/
void SpiLpm()
{
    if(UxTCTL&SSEL0) LPM3;  //ACLK ʱӣLPM3(ACLK)
    else             LPM0;  //SMCLKʱӣLPM0(رSMCLK)
}

/****************************************************************************
*     ƣUartWriteChar
*     ܣ򴮿дһֽ
* ڲc:  ͵һֽ
* ڲ
* ˵    : ڵȴϵĹУCPU
****************************************************************************/
void SpiWriteDat(char c)
{ 
    while (TxFlag==0) SpiLpm();  // ȴһֽڷ꣬
    TxFlag=0;                     //
    UxTXBUF=c;
}

/****************************************************************************
*     ƣUartReadChar
*     ܣӴڶȡ1ֽ
* ڲ  
* ڲյһֽ
* ˵    : ûݣһֱȴȴУCPU
****************************************************************************/
char SpiReadDat()
{ 
    while (RxFlag==0) SpiLpm(); // յһֽ?
    RxFlag=0;
    return(UxRXBUF);
}

/****************************************************************************
*     ƣSpiWriteData
*     ܣзصд
* ڲc:  ͵һֽ
* ڲcharдͬʱյֽ
* ˵    : SPIȫ˫ͨţÿηͣʱҲڽգɺİʱ
*           ں󣬶һַַҲǴ豸صģź
*           ĬϵƽʵжϣֻʱҲҪô˺
*           ûʱṩ豸ܶݣǿҽʹʱͽֻ
*           ˺ȡĿһβַ \0Ĭϵƽ
****************************************************************************/
char SpiWriteData(char c)
{
    SpiWriteDat(c);
    return SpiReadDat();
}

/****************************************************************************
*     ƣUartRx
*     ܣڽжϣÿյ1ֽڻᷢһж
****************************************************************************/
#pragma vector=USARTxRX_VECTOR
__interrupt void UartRx()
{
    RxFlag=1;
    __low_power_mode_off_on_exit();
}

/****************************************************************************
*     ƣUartTx
*     ܣڷжϣÿ1ֽڻᷢһж
****************************************************************************/
#pragma vector=USARTxTX_VECTOR
__interrupt void UartTx ()
{
    TxFlag=1;
    __low_power_mode_off_on_exit();
}
