/*----------------------------------------------------------------
 * Copyright (C) 2011 մѧ ѧԺ416 ԭ
 * ȨС 
 * 
 * ļ Lcd12864.c
 * 
 * ļ   
 *          MSP430F16x,MSP430F14XϵеƬ12864Һ
 *      ˵  
 *          ó12864ײҺıдΪ
 *          ĵײʹ
 *          ʹʱֻLcd12864.cӵУȻҪҺ
 *          ԴļмLcd12864.hİȻͿԵ
 *          ͷļĸ
 *          
 * ʶ   ԭ20110707
 * 
 * ޸ıʶ   ԭ20110729
 * ޸   LcdReadAddrLcdReadDataֲprintf
 * 
 * ޸ıʶ   ԭ20110828
 * ޸   GotoXYӦλڴļGotoXYƶ
**----------------------------------------------------------------*/

#include <msp430x16x.h>
#include "Lcd12864.h"

/**********************************궨**************************************/

#define DATA_DIR_IN     P5DIR&=~0XFF
#define DATA_DIR_OUT	P5DIR|=0XFF
#define CTRL_DIR_OUT    P3DIR|=0X07
#define DATA_IN         P5IN
#define DATA_OUT        P5OUT
#define CLR_RS          P3OUT&=~BIT0
#define SET_RS          P3OUT|=BIT0
#define CLR_RW          P3OUT&=~BIT1
#define SET_RW          P3OUT|=BIT1
#define CLR_EN          P3OUT&=~BIT2
#define SET_EN          P3OUT|=BIT2

/******************************************************************************/


/*******************************************
ƣDelay1ms
    ܣʱԼ1msʱ
    
ֵ  
********************************************/
void Delay1ms(void)
{
    char i;
    
    for(i = 150;i > 0;i--)  _NOP();
} 

/*******************************************
ƣDelayNms
    ܣʱN1msʱ
    n--ʱ
ֵ  
********************************************/
void DelayNms(int n)
{
    int i;
    
    for(i = n;i > 0;i--)    Delay1ms();
}

/*******************************************
ƣWaitForEnable
    ܣæȵæ
    
ֵ  
********************************************/
void WaitForEnable()
{
    char busy;
    
    CLR_RS;
    SET_RW;
    
    DATA_DIR_IN;
    
    do                       //æ
    {
        SET_EN;
        _NOP();					
        busy = DATA_IN; 
        CLR_EN;
    }
    while(busy & 0x80); 
    
    DATA_DIR_OUT;
}

/*******************************************
ƣLcdWriteComm
    ܣҺд
    cmd--
ֵ  
********************************************/
void LcdWriteComm(char cmd)
{
    WaitForEnable();    //æźţ
    
    CLR_RS;
    CLR_RW;
    
    DATA_OUT = cmd;	//д
    
    SET_EN;
    _NOP();
    CLR_EN;
}

/*******************************************
ƣLcdWriteData
    ܣҺдʾ
    data--ʾ
ֵ  
********************************************/
void LcdWriteData(char data)
{
    WaitForEnable();
    
    SET_RS;
    CLR_RW;
    
    DATA_OUT = data;	//д
    
    SET_EN;
    _NOP();
    CLR_EN;
}

/*******************************************
ƣLcdInit
    ܣʼҺģ
    
ֵ  
********************************************/
void LcdInit()
{
    CTRL_DIR_OUT;
    
    DelayNms(500);
    LcdWriteComm(0x30);     //ָ
    LcdWriteComm(0x01);     //ַ00H
    LcdWriteComm(0x06);     //ƶ
    LcdWriteComm(0x0c);     //ʾα
}

/*******************************************
ƣLcdWriteString
    ܣҺдַǺ
    
        addrдַʾַ
             0x80-0x87һ
             0x90-0x97ڶ
             0x88-0x8F
             0x98-0x9F
        strҪʾַ,ԭַ
             Ӣַһ
             ֻһһո
ֵ  
********************************************/
void LcdWriteString(char addr,char *str)
{
    LcdWriteComm(addr);
    while(*str!='\0')
    {
        LcdWriteData(*str);
        str++;
    }
}

/*******************************************
ƣLcdReadData
    ܣҺжȡ
    
ֵ  ȡõ
********************************************/
char LcdReadData()
{
    char ch;
    
    WaitForEnable();
    
    SET_RS;
    SET_RW;
    
    DATA_DIR_IN;
    
    SET_EN;
    _NOP();
    
    ch = DATA_IN;	//
    CLR_EN;
    DATA_DIR_OUT;
    
    return ch;
}

/*******************************************
ƣLcdReadAddr
    ܣҺжȡǰλõַ
    
ֵ  ȡõĵַ0x80-0x9F
********************************************/
char LcdReadAddr()
{
    char ch;
    
    WaitForEnable();
    
    CLR_RS;
    SET_RW;
    
    DATA_DIR_IN;
    
    SET_EN;
    _NOP();
    
    ch = DATA_IN;	//
    CLR_EN;
    DATA_DIR_OUT;
    
    return (ch|0x80);
}

/****************************************************************************
*     ƣGotoXY
*     ܣλҺľλãxy0-15,0-3
* ڲ
* ڲ
* ˵    : printf֮ǰô˺ԶλҺľλãż
            ЧԶһλ
****************************************************************************/
void GotoXY(char x,char y)
{
    char addr;
    
    if(y==0)
    {
        addr = 0x80 + x / 2;
    }
    else if(y==1)
    {
        addr = 0x90 + x / 2;
    }
    else if(y==2)
    {
        addr = 0x88 + x / 2;
    }
    else
    {
        addr = 0x98 + x / 2;
    }
    LcdWriteComm(addr);
    if(x % 2)                   //һλдո
    {
        LcdWriteData(0x20);
    }
}