/*----------------------------------------------------------------
 * Copyright (C) 2011 մѧ ѧԺ416 ԭ
 * ȨС 
 * 
 * ļ Printf.c  Ϊ PutChar.c
 * 
 * ļ   
 *          MSP430F16x,MSP430F14XϵеƬprintfֲ
 *      ˵  
 *          óprintfֲprintfͬʱҺUart0
 *          ʾ
 *          ʹʱֻPrintf.cӵУȻҪprintf
 *          Դļмstdio.hİ ȻͿ
 *          printfˣ⣬ҺҪλ
 *          GotoXYPrintf.hļ( Һ
 *          )
 *          
 * ʶ   ԭ20110729
 * 
 * ޸ıʶ   ԭ20110820
 * ޸   Һprintf֧˸ڴ˸֧֣˸ں
 *               putchar2Lcd,ַ=\b=\x8ʱã˸:BackSpace
 * 
 * ޸ıʶ   ԭ20110827
 * ޸   GotoXYӦλڴļGotoXYƶҺ
 *              ΪPutChar.c ļ
**----------------------------------------------------------------*/

#include <msp430x16x.h>
#include "Lcd12864.h"

/****************************************************************************
*     ƣAddNewline
*     ܣҺдһУƶ
* ڲ
* ڲ
* ˵    : ˺putchar2LcdãҺԶϹ
****************************************************************************/
void AddNewline()
{
    char str[17];
    str[16] = 0;
    
    //ڶ һ
    LcdWriteComm(0x90);
    LcdReadData();              //նȡ
    for(int i = 0;i<16;i++)
    {
        str[i] = LcdReadData();
    }
    LcdWriteString(0x80,str);
    
    // ڶ
    LcdWriteComm(0x88);
    LcdReadData();
    for(int i = 0;i<16;i++)
    {
        str[i] = LcdReadData();
    }
    LcdWriteString(0x90,str);
    
    // 
    LcdWriteComm(0x98);
    LcdReadData();
    for(int i = 0;i<16;i++)
    {
        str[i] = LcdReadData();
    }
    LcdWriteString(0x88,str);
    
    // հ
    LcdWriteString(0x98,"                ");    //ʮո
}

/****************************************************************************
*     ƣChangeNextRow
*     ܣҺʾһ
* ڲ
* ڲ
* ˵    : ˺putchar2LcdãҺһдз󣬵
            ô˺дһС
****************************************************************************/
void ChangeNextRow()
{
    char addr;
    
    addr = LcdReadAddr();       //ǰַ
    if(addr <= 0x88)
    {
        LcdWriteComm(0x90);
    }
    else if(addr <= 0x90)
    {
        LcdWriteComm(0x98);
    }
    else if(addr <= 0x98)
    {
        LcdWriteComm(0x88);
    }
    else
    {
        AddNewline();           //УͬʱϹ
        LcdWriteComm(0x98);
    }
}

/****************************************************************************
*     ƣBackSpace
*     ܣҺʾ˸񣬵ַָǰһ˰֣
* ڲ
* ڲ
* ˵    : ˺putchar2LcdãҺյ˸ַ󣬵ô˺
            ַ˻һ(Ӣģ֣ģһ)
****************************************************************************/
void BackSpace()
{
    char addr,dat;
    
    addr = LcdReadAddr();       //ǰַ
    LcdWriteData(0x20);         //дһַݵַжǷΪǰ
    if(addr == LcdReadAddr())   //ǰ
    {
        if(addr == 0x80)
            return;
        else if(addr == 0x90)
            addr = 0x87;
        else if(addr == 0x88)
            addr = 0x97;
        else if(addr == 0x98)
            addr = 0x8F;
        else 
            addr = addr - 1;
       
        LcdWriteComm(addr);
        LcdReadData();          //նȡ
        dat = LcdReadData();
        LcdWriteComm(addr);
        if(dat < 0x80)
            LcdWriteData(dat);
    }
    else
    {
        LcdWriteComm(addr);
    }
}

/****************************************************************************
*     ƣputchar
*     ܣ12864Һ豸һֽ(1ASCIIַ)
* ڲch: ͵ַ  
* ڲַ
* ˵    : printføúΪײַ12864Һ
            printfĽӡ12864Һϡ޸ĸú
            ʽ첽ͨPCĳնˣ printfĽ
            ʾڳն
****************************************************************************/
int putchar(int ch)
{
    char addr,dat;
    char changeRowFlag = 0;
    
    if (ch == '\n')         //  '\n'(س),
    {
        ChangeNextRow();
        changeRowFlag = 1;
    }
    else if (ch == '\b')    // '\b' (˸)
    {
        BackSpace();
    }
    else
    {
        addr = LcdReadAddr();
        if(ch < 0x80)
        {
            LcdWriteData(ch);
        }
        else
        {
            LcdWriteData(0x20);     //дһַݵַжǷΪǰ
            if(addr == LcdReadAddr())   //ǰ дchַ
            {
                LcdWriteComm(addr);
                LcdWriteData(ch);
            }
            else
            {
                LcdWriteComm(addr);
                dat = LcdReadData();
                if(dat < 0x80)           //ǰһַӢַ
                {
                    LcdWriteData(0x20);                 //ո
                }
                if((addr != LcdReadAddr()) &&               //дλĺ
                   (addr==0x87 || addr==0x97 || addr==0x8F || addr==0x9F))
                {
                    ChangeNextRow();
                    changeRowFlag = 1;
                }
                LcdWriteData(ch);
            }
        }
    }
    if((addr != LcdReadAddr()) &&   //дλĺ,δ
       (changeRowFlag == 0) &&   
       (addr==0x87 || addr==0x97 || addr==0x8F || addr==0x9F))
    {
        ChangeNextRow();
    }
    return (ch);
}
